/*
 * $Id$
 */

package org.codehaus.mojo.appassembler.model;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;

/**
 * null
 * 
 * @version $Revision$ $Date$
 */
public class Daemon implements java.io.Serializable {


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field id
     */
    private String id;

    /**
     * Field mainClass
     */
    private String mainClass;

    /**
     * Field classpath
     */
    private Classpath classpath;

    /**
     * Field commandLineArguments
     */
    private java.util.List commandLineArguments;

    /**
     * Field jvmSettings
     */
    private JvmSettings jvmSettings;

    /**
     * Field environmentSetupFileName
     */
    private String environmentSetupFileName;

    /**
     * Field showConsoleWindow
     */
    private boolean showConsoleWindow = true;

    /**
     * Field generatorConfigurations
     */
    private java.util.List generatorConfigurations;

    /**
     * Field repositoryName
     */
    private String repositoryName = "repo";


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addCommandLineArgument
     * 
     * @param string
     */
    public void addCommandLineArgument(String string)
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "Daemon.addCommandLineArguments(string) parameter must be instanceof " + String.class.getName() );
        }
        getCommandLineArguments().add( string );
    } //-- void addCommandLineArgument(String) 

    /**
     * Method addGeneratorConfiguration
     * 
     * @param generatorConfiguration
     */
    public void addGeneratorConfiguration(GeneratorConfiguration generatorConfiguration)
    {
        if ( !(generatorConfiguration instanceof GeneratorConfiguration) )
        {
            throw new ClassCastException( "Daemon.addGeneratorConfigurations(generatorConfiguration) parameter must be instanceof " + GeneratorConfiguration.class.getName() );
        }
        getGeneratorConfigurations().add( generatorConfiguration );
    } //-- void addGeneratorConfiguration(GeneratorConfiguration) 

    /**
     * Get null
     */
    public Classpath getClasspath()
    {
        return this.classpath;
    } //-- Classpath getClasspath() 

    /**
     * Method getCommandLineArguments
     */
    public java.util.List getCommandLineArguments()
    {
        if ( this.commandLineArguments == null )
        {
            this.commandLineArguments = new java.util.ArrayList();
        }
        
        return this.commandLineArguments;
    } //-- java.util.List getCommandLineArguments() 

    /**
     * Get null
     */
    public String getEnvironmentSetupFileName()
    {
        return this.environmentSetupFileName;
    } //-- String getEnvironmentSetupFileName() 

    /**
     * Method getGeneratorConfigurations
     */
    public java.util.List getGeneratorConfigurations()
    {
        if ( this.generatorConfigurations == null )
        {
            this.generatorConfigurations = new java.util.ArrayList();
        }
        
        return this.generatorConfigurations;
    } //-- java.util.List getGeneratorConfigurations() 

    /**
     * Get null
     */
    public String getId()
    {
        return this.id;
    } //-- String getId() 

    /**
     * Get null
     */
    public JvmSettings getJvmSettings()
    {
        return this.jvmSettings;
    } //-- JvmSettings getJvmSettings() 

    /**
     * Get null
     */
    public String getMainClass()
    {
        return this.mainClass;
    } //-- String getMainClass() 

    /**
     * Get null
     */
    public String getRepositoryName()
    {
        return this.repositoryName;
    } //-- String getRepositoryName() 

    /**
     * Get null
     */
    public boolean isShowConsoleWindow()
    {
        return this.showConsoleWindow;
    } //-- boolean isShowConsoleWindow() 

    /**
     * Method removeCommandLineArgument
     * 
     * @param string
     */
    public void removeCommandLineArgument(String string)
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "Daemon.removeCommandLineArguments(string) parameter must be instanceof " + String.class.getName() );
        }
        getCommandLineArguments().remove( string );
    } //-- void removeCommandLineArgument(String) 

    /**
     * Method removeGeneratorConfiguration
     * 
     * @param generatorConfiguration
     */
    public void removeGeneratorConfiguration(GeneratorConfiguration generatorConfiguration)
    {
        if ( !(generatorConfiguration instanceof GeneratorConfiguration) )
        {
            throw new ClassCastException( "Daemon.removeGeneratorConfigurations(generatorConfiguration) parameter must be instanceof " + GeneratorConfiguration.class.getName() );
        }
        getGeneratorConfigurations().remove( generatorConfiguration );
    } //-- void removeGeneratorConfiguration(GeneratorConfiguration) 

    /**
     * Set null
     * 
     * @param classpath
     */
    public void setClasspath(Classpath classpath)
    {
        this.classpath = classpath;
    } //-- void setClasspath(Classpath) 

    /**
     * Set null
     * 
     * @param commandLineArguments
     */
    public void setCommandLineArguments(java.util.List commandLineArguments)
    {
        this.commandLineArguments = commandLineArguments;
    } //-- void setCommandLineArguments(java.util.List) 

    /**
     * Set null
     * 
     * @param environmentSetupFileName
     */
    public void setEnvironmentSetupFileName(String environmentSetupFileName)
    {
        this.environmentSetupFileName = environmentSetupFileName;
    } //-- void setEnvironmentSetupFileName(String) 

    /**
     * Set null
     * 
     * @param generatorConfigurations
     */
    public void setGeneratorConfigurations(java.util.List generatorConfigurations)
    {
        this.generatorConfigurations = generatorConfigurations;
    } //-- void setGeneratorConfigurations(java.util.List) 

    /**
     * Set null
     * 
     * @param id
     */
    public void setId(String id)
    {
        this.id = id;
    } //-- void setId(String) 

    /**
     * Set null
     * 
     * @param jvmSettings
     */
    public void setJvmSettings(JvmSettings jvmSettings)
    {
        this.jvmSettings = jvmSettings;
    } //-- void setJvmSettings(JvmSettings) 

    /**
     * Set null
     * 
     * @param mainClass
     */
    public void setMainClass(String mainClass)
    {
        this.mainClass = mainClass;
    } //-- void setMainClass(String) 

    /**
     * Set null
     * 
     * @param repositoryName
     */
    public void setRepositoryName(String repositoryName)
    {
        this.repositoryName = repositoryName;
    } //-- void setRepositoryName(String) 

    /**
     * Set null
     * 
     * @param showConsoleWindow
     */
    public void setShowConsoleWindow(boolean showConsoleWindow)
    {
        this.showConsoleWindow = showConsoleWindow;
    } //-- void setShowConsoleWindow(boolean) 


            public java.util.List getAllClasspathElements()
            {
                if ( classpath == null )
                {
                    return java.util.Collections.EMPTY_LIST;
                }

                java.util.List elements = new java.util.ArrayList(
                    classpath.getDependencies().size() + classpath.getDirectories().size() );
                elements.addAll( classpath.getDirectories() );
                elements.addAll( classpath.getDependencies() );
                return elements;
            }
              
    private String modelEncoding = "UTF-8";

    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    public String getModelEncoding()
    {
        return modelEncoding;
    }
}
